
#ifndef __H_TEST__
#define __H_TEST__

#include <stdio.h>

#ifndef RESET
/* Colour definitions for console prints */
#define RESET   "\033[0m"
#define BLACK   "\033[30m"      /* Black */
#define RED     "\033[31m"      /* Red */
#define GREEN   "\033[32m"      /* Green */
#define YELLOW  "\033[33m"      /* Yellow */
#define BLUE    "\033[34m"      /* Blue */
#define MAGENTA "\033[35m"      /* Magenta */
#define CYAN    "\033[36m"      /* Cyan */
#define WHITE   "\033[37m"      /* White */
#define BOLDBLACK   "\033[1m\033[30m"      /* Bold Black */
#define BOLDRED     "\033[1m\033[31m"      /* Bold Red */
#define BOLDGREEN   "\033[1m\033[32m"      /* Bold Green */
#define BOLDYELLOW  "\033[1m\033[33m"      /* Bold Yellow */
#define BOLDBLUE    "\033[1m\033[34m"      /* Bold Blue */
#define BOLDMAGENTA "\033[1m\033[35m"      /* Bold Magenta */
#define BOLDCYAN    "\033[1m\033[36m"      /* Bold Cyan */
#define BOLDWHITE   "\033[1m\033[37m"      /* Bold White */
#endif

#define test_fail(p, ...)\
  fprintf (stderr, RED "[FAILED][%s:%d, %s] " p " \n" RESET,\
  __FILE__, __LINE__, __func__ , ##__VA_ARGS__)

#define test_pass(p, ...)\
   fprintf (stdout, GREEN "[PASS] " p " \n" RESET,\
   ##__VA_ARGS__)

#define test_case(cond, p, ret)     \
    if (cond) {                     \
      test_pass(p);                 \
    } else {                        \
      test_fail(p);                 \
      ret++;                        \
    }

#endif /* __H_TEST__ */
